// Lab 2: ColorGUI.java
// Program that enables the user to change the foreground and 
// background colors of a JTextArea.
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ColorGUI extends JFrame {
   private JPanel panel1, panel2, panel3;
   private JTextArea area;
   private JComboBox colorList;
   private JRadioButton backBox, foreBox;
   private ButtonGroup colorGroup;
   private JButton apply;
   private Color backColor, foreColor, selected;
   private boolean background = false;
   private Container container;

   private String colorNames[] = 
      { "RED", "BLUE", "GREEN", "YELLOW", "MAGENTA", "CYAN" }; 
   private Color colors[] = { Color.RED, Color.BLUE, Color.GREEN, 
      Color.YELLOW, Color.MAGENTA, Color.CYAN };

   // set up GUI and initialize values
   public ColorGUI()
   {
      /* Write a statement that calls the superclass constructor
         and sets the title of this application to "Color GUI" */

      /* Write a statement that sets Color member variable "selected" to red */

      // create GUI components
      area = new JTextArea( 3, 20 );
      area.setFont( new Font( null, Font.ITALIC, 16 ) );
      area.setText( "Type text here" );
   
      // sets the area so that text will wrap to the next line
      area.setLineWrap( true );
      area.setEditable( true );

      colorList = new JComboBox( colorNames );
      colorList.setSelectedIndex( 0 );
      colorList.addItemListener( new ListHandler() );
      
      backBox = new JRadioButton( "background", false );
      foreBox = new JRadioButton( "foreground", false );
      backBox.addItemListener( new RadioButtonHandler() );
      foreBox.addItemListener( new RadioButtonHandler() );

      /* Write code that creates a new ButtonGroup and adds the 
         backBox and foreBox JRadioButtons to the ButtonGroup */
   
      apply = new JButton( "Apply" );
      apply.setEnabled( false );
      apply.addActionListener( new ButtonHandler() );

      // create panels and add components to the panels
      /* Write code that creates three new JPanels (panel1, panel2 and panel3) */

      /* Write code adds the GUI components to the JPanels as follows: 
         add area to panel1; add colorList, backBox, and foreBox to panel2; 
         and add apply to panel3 */
         
      // add panels to container
      container = getContentPane();
      container.setLayout( new FlowLayout() );
      /* Write code that adds the three JPanels to the container */

      setSize( 300, 200 );
      setVisible( true );
   }

   // inner class for button actions
   private class ButtonHandler implements ActionListener
   {
      public void actionPerformed( ActionEvent event )
      {
         // set backColor or foreColor based on the value of 
         // instance variable "background"
         /* Write code that determines whether boolean instance variable
            "background" is true. If so, set instance variable backColor to the
            selected Color and set the background color of the JTextArea. 
            Otherwise set foreColor to the selected Color and set the forground
            color of the JTextArea */

         /* Write a statement that repaints the JTextArea */
      } // end actionPerformed method

   } // end inner class ButtonHandler

   // inner class for radio button actions
   private class RadioButtonHandler implements ItemListener {

      public void itemStateChanged( ItemEvent event )
      {
         /* Write code that sets instance variable "background" to true if 
            backBox is selected or false if foreBox is selected */
         
         /* Write a statement that enables the apply Button */

      } // end itemStateChanged method

   } // end inner class RadioButtonHandler

   // inner class for actions in colorList combo box
   private class ListHandler implements ItemListener {

      public void itemStateChanged( ItemEvent event )
      {
         selected = colors[ colorList.getSelectedIndex() ];
           
      } // end itemStateChanged method

   } // end inner class ListHandler


   // execute application
   public static void main( String args[] )
   {
      ColorGUI application = new ColorGUI();
      application.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
   }

} // end class ColorGUI
